diff --git a/README.md b/README.md
index 9b363da..0d3c833 100644
--- a/README.md
+++ b/README.md
@@ -101,11 +101,15 @@ As of `v0.4.0`, suggestions are fetched asynchronously using the `zsh/zpty` modu
### Key Bindings
-This plugin provides three widgets that you can use with `bindkey`:
+This plugin provides a few widgets that you can use with `bindkey`:
1. `autosuggest-accept`: Accepts the current suggestion.
2. `autosuggest-execute`: Accepts and executes the current suggestion.
3. `autosuggest-clear`: Clears the current suggestion.
+4. `autosuggest-fetch`: Fetches a suggestion (works even when suggestions are disabled).
+5. `autosuggest-disable`: Disables suggestions.
+6. `autosuggest-enable`: Re-enables suggestions.
+7. `autosuggest-toggle`: Toggles between enabled/disabled suggestions.
For example, this would bind ctrl + space to accept the current suggestion.
diff --git a/spec/widgets/disable_spec.rb b/spec/widgets/disable_spec.rb
new file mode 100644
index 0000000..b387a59
--- /dev/null
+++ b/spec/widgets/disable_spec.rb
@@ -0,0 +1,19 @@
+describe 'the `autosuggest-disable` widget' do
+ before do
+ session.run_command('bindkey ^B autosuggest-disable')
+ end
+
+ it 'disables suggestions and clears the suggestion' do
+ with_history('echo hello') do
+ session.send_string('echo')
+ wait_for { session.content }.to eq('echo hello')
+
+ session.send_keys('C-b')
+ wait_for { session.content }.to eq('echo')
+
+ session.send_string(' h')
+ sleep 1
+ expect(session.content).to eq('echo h')
+ end
+ end
+end
diff --git a/spec/widgets/enable_spec.rb b/spec/widgets/enable_spec.rb
new file mode 100644
index 0000000..0322406
--- /dev/null
+++ b/spec/widgets/enable_spec.rb
@@ -0,0 +1,21 @@
+describe 'the `autosuggest-enable` widget' do
+ before do
+ session.
+ run_command('typeset -g _ZSH_AUTOSUGGEST_DISABLED').
+ run_command('bindkey ^B autosuggest-enable')
+ end
+
+ it 'enables suggestions and fetches a suggestion' do
+ with_history('echo world', 'echo hello') do
+ session.send_string('echo')
+ sleep 1
+ expect(session.content).to eq('echo')
+
+ session.send_keys('C-b')
+ wait_for { session.content }.to eq('echo hello')
+
+ session.send_string(' w')
+ wait_for { session.content }.to eq('echo world')
+ end
+ end
+end
diff --git a/spec/widgets/fetch_spec.rb b/spec/widgets/fetch_spec.rb
new file mode 100644
index 0000000..eb8f2ba
--- /dev/null
+++ b/spec/widgets/fetch_spec.rb
@@ -0,0 +1,24 @@
+describe 'the `autosuggest-fetch` widget' do
+ context 'when suggestions are disabled' do
+ before do
+ session.
+ run_command('bindkey ^B autosuggest-disable').
+ run_command('bindkey ^F autosuggest-fetch').
+ send_keys('C-b')
+ end
+
+ it 'will fetch and display a suggestion' do
+ with_history('echo hello') do
+ session.send_string('echo h')
+ sleep 1
+ expect(session.content).to eq('echo h')
+
+ session.send_keys('C-f')
+ wait_for { session.content }.to eq('echo hello')
+
+ session.send_string('e')
+ wait_for { session.content }.to eq('echo hello')
+ end
+ end
+ end
+end
diff --git a/spec/widgets/toggle_spec.rb b/spec/widgets/toggle_spec.rb
new file mode 100644
index 0000000..8f9f3c3
--- /dev/null
+++ b/spec/widgets/toggle_spec.rb
@@ -0,0 +1,26 @@
+describe 'the `autosuggest-toggle` widget' do
+ before do
+ session.run_command('bindkey ^B autosuggest-toggle')
+ end
+
+ it 'toggles suggestions' do
+ with_history('echo world', 'echo hello') do
+ session.send_string('echo')
+ wait_for { session.content }.to eq('echo hello')
+
+ session.send_keys('C-b')
+ wait_for { session.content }.to eq('echo')
+
+ session.send_string(' h')
+ sleep 1
+ expect(session.content).to eq('echo h')
+
+ session.send_keys('C-b')
+ wait_for { session.content }.to eq('echo hello')
+
+ session.send_keys('C-h')
+ session.send_string('w')
+ wait_for { session.content }.to eq('echo world')
+ end
+ end
+end
diff --git a/src/widgets.zsh b/src/widgets.zsh
index 7f15a27..2bcedc4 100644
--- a/src/widgets.zsh
+++ b/src/widgets.zsh
@@ -3,6 +3,27 @@
# Autosuggest Widget Implementations #
#--------------------------------------------------------------------#
+# Disable suggestions
+_zsh_autosuggest_disable() {
+ typeset -g _ZSH_AUTOSUGGEST_DISABLED
+ _zsh_autosuggest_clear
+}
+
+# Enable suggestions
+_zsh_autosuggest_enable() {
+ unset _ZSH_AUTOSUGGEST_DISABLED
+ _zsh_autosuggest_fetch
+}
+
+# Toggle suggestions (enable/disable)
+_zsh_autosuggest_toggle() {
+ if [ -n "${_ZSH_AUTOSUGGEST_DISABLED+x}" ]; then
+ _zsh_autosuggest_enable
+ else
+ _zsh_autosuggest_disable
+ fi
+}
+
# Clear the suggestion
_zsh_autosuggest_clear() {
# Remove the suggestion
@@ -51,6 +72,11 @@ _zsh_autosuggest_modify() {
return $retval
fi
+ # Bail out if suggestions are disabled
+ if [ -n "${_ZSH_AUTOSUGGEST_DISABLED+x}" ]; then
+ return $?
+ fi
+
# Get a new suggestion if the buffer is not empty after modification
if [ $#BUFFER -gt 0 ]; then
if [ -z "$ZSH_AUTOSUGGEST_BUFFER_MAX_SIZE" -o $#BUFFER -le "$ZSH_AUTOSUGGEST_BUFFER_MAX_SIZE" ]; then
@@ -150,7 +176,7 @@ _zsh_autosuggest_partial_accept() {
return $retval
}
-for action in clear modify fetch suggest accept partial_accept execute; do
+for action in clear modify fetch suggest accept partial_accept execute enable disable toggle; do
eval "_zsh_autosuggest_widget_$action() {
local -i retval
@@ -172,3 +198,6 @@ zle -N autosuggest-suggest _zsh_autosuggest_widget_suggest
zle -N autosuggest-accept _zsh_autosuggest_widget_accept
zle -N autosuggest-clear _zsh_autosuggest_widget_clear
zle -N autosuggest-execute _zsh_autosuggest_widget_execute
+zle -N autosuggest-enable _zsh_autosuggest_widget_enable
+zle -N autosuggest-disable _zsh_autosuggest_widget_disable
+zle -N autosuggest-toggle _zsh_autosuggest_widget_toggle
diff --git a/zsh-autosuggestions.zsh b/zsh-autosuggestions.zsh
index 2b41154..96b69a9 100644
--- a/zsh-autosuggestions.zsh
+++ b/zsh-autosuggestions.zsh
@@ -281,6 +281,27 @@ _zsh_autosuggest_highlight_apply() {
# Autosuggest Widget Implementations #
#--------------------------------------------------------------------#
+# Disable suggestions
+_zsh_autosuggest_disable() {
+ typeset -g _ZSH_AUTOSUGGEST_DISABLED
+ _zsh_autosuggest_clear
+}
+
+# Enable suggestions
+_zsh_autosuggest_enable() {
+ unset _ZSH_AUTOSUGGEST_DISABLED
+ _zsh_autosuggest_fetch
+}
+
+# Toggle suggestions (enable/disable)
+_zsh_autosuggest_toggle() {
+ if [ -n "${_ZSH_AUTOSUGGEST_DISABLED+x}" ]; then
+ _zsh_autosuggest_enable
+ else
+ _zsh_autosuggest_disable
+ fi
+}
+
# Clear the suggestion
_zsh_autosuggest_clear() {
# Remove the suggestion
@@ -329,6 +350,11 @@ _zsh_autosuggest_modify() {
return $retval
fi
+ # Bail out if suggestions are disabled
+ if [ -n "${_ZSH_AUTOSUGGEST_DISABLED+x}" ]; then
+ return $?
+ fi
+
# Get a new suggestion if the buffer is not empty after modification
if [ $#BUFFER -gt 0 ]; then
if [ -z "$ZSH_AUTOSUGGEST_BUFFER_MAX_SIZE" -o $#BUFFER -le "$ZSH_AUTOSUGGEST_BUFFER_MAX_SIZE" ]; then
@@ -428,7 +454,7 @@ _zsh_autosuggest_partial_accept() {
return $retval
}
-for action in clear modify fetch suggest accept partial_accept execute; do
+for action in clear modify fetch suggest accept partial_accept execute enable disable toggle; do
eval "_zsh_autosuggest_widget_$action() {
local -i retval
@@ -450,6 +476,9 @@ zle -N autosuggest-suggest _zsh_autosuggest_widget_suggest
zle -N autosuggest-accept _zsh_autosuggest_widget_accept
zle -N autosuggest-clear _zsh_autosuggest_widget_clear
zle -N autosuggest-execute _zsh_autosuggest_widget_execute
+zle -N autosuggest-enable _zsh_autosuggest_widget_enable
+zle -N autosuggest-disable _zsh_autosuggest_widget_disable
+zle -N autosuggest-toggle _zsh_autosuggest_widget_toggle
#--------------------------------------------------------------------#
# Default Suggestion Strategy #